/*  

    Panda -  A modular programming language.
    written by Giovanni Petrantoni.
    Copyright (c) 2003 - 2004, Giovanni Petrantoni.
    http://xpanda.sf.net/
    
    panda.h - Panda API
    
    This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.


	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
	Lesser General Public License for more details.


	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
	
	elementicaotici - by Johnny (Giovanni) Petrantoni, ITALY - Rome.
	e-mail: johnny@lato-b.com
	
*/


#include <Panda/panda_drivers.h>

#ifdef __cplusplus
extern "C" {
#endif

int OpenModule(char *name,int argc, char *argv[]);

void CloseModule(int ID);

int ModuleIsLoaded(int ID);

ParamList GetModuleParameters(int ID);

void HELP(int ID);

void HELPME(char *moduleName);

void ExecuteMethod(int ID,int inlet,void *VAR);

int Connect(int fromID,int fromOutlet,int toID,int toInlet);

int Disconnect(int fromID,int fromOutlet,int toID,int toInlet);

int Audio_Connect(int fromID,int fromOutlet,int toID,int toInlet);

int Audio_Disconnect(int fromID,int fromOutlet,int toID,int toInlet);

// Panda DEFAULT (AUHAL) audio services:

void InitAudioEngine(float sampleRate,long bufferSize,int inChannels, int outChannels, char *device);

void KillAudioEngine();

int DSP_ON();

int DSP_OFF();

//--------------------------

// Panda audio services:

int AudioEngineSelect(char *audioEngineName); 

int AudioEngineSetParameter(int parameter,void *inValues);

int AudioEngineGetParameter(int parameter,void *outValues);

DriverParamList AudioEngineGetParametersList();

int AudioEngineCreate();

int AudioEngineStart();

int AudioEngineStop();

void deleteAudioEngine();

//--------------------------

// Panda such a Plugin stuff:

void * InitPluginAudioEngine(char *instanceName,float sampleRate,long bufferSize,int inChannels, int outChannels,void *thePlugin);

void addModuleAtInstance(int moduleID,char *instanceName);

int closePluginInstace(char *instanceName);

int panda_PluginDoRender(char *instanceName,long nframes);

//--------------------------

// Status saving stuff:

int _savePandaStatusToFile(const char *fileName);

int _loadPandaStatusFromFile(const char *fileName);

int _pandaStatusFromFileNeedsAudio(const char *fileName);

int _savePandaStatusToFile_Plugin(const char *fileName);

int _pandaStatusFromFileForPluginGetInfo(const char *fileName,int info);

int _loadPandaStatusFromFile_Plugin(const char *fileName,const char *instanceName);

//-------------------

// Stuff for using Panda as an Application plugin core

void changeModulesSearchDirectory(char *newDirectory); // must be like "/Library/Audio/Plug-Ins/MYPLUGINFORMAT/"

void changeModulesBundleExtension(char *newExtension); // must be like ".mypluginextension"

//--------------------------

#ifdef __cplusplus
}
#endif